<template>
    <div>
        <el-card class="el-card">
            <el-form :model="filterQuery" label-width="100px" v-show="showSearch">
              <el-row>
                <el-col :span="6">
                <el-form-item label="产品编码:">
                    <el-input v-model="filterQuery.code" style="width: 90%"  placeholder="请输入产品编码/商品条码/医保编码" clearable @keyup.enter.native="keyupErp_submit($event)"></el-input>
                </el-form-item>
                </el-col>
                <el-col :span="6">
                <el-form-item label="产品名称:">
                    <el-input v-model="filterQuery.name" style="width: 90%"  clearable placeholder="请输入产品名称"></el-input>
                </el-form-item>
                </el-col>
                <el-col :span="6">
                <el-form-item label="规格型号:">
                    <el-input v-model="filterQuery.spec" style="width: 90%"  clearable placeholder="请输入规格型号"></el-input>
                </el-form-item>
                </el-col>
                <el-col :span="6">
                <el-form-item label="注册人:">
                    <el-input v-model="filterQuery.registerNo" clearable style="width: 90%" placeholder="请输入注册/备案凭证"></el-input>
                </el-form-item>
                </el-col>
              </el-row>
              <el-row>
                <el-col :span="6">
                <el-form-item label="审核状态:">
                    <el-select v-model="filterQuery.checkStatus" style="width: 90%"  placeholder="请选择审核状态">
                        <el-option label="全部" value=""></el-option>
                        <el-option label="已审核" value="2"></el-option>
                        <el-option label="未审核" value="1"></el-option>
                        <el-option label="未通过" value="3"></el-option>
                    </el-select>
                </el-form-item>
                </el-col>
                <el-col :span="6">
                <el-form-item label="外部系统:">
                    <el-select v-model="filterQuery.thirdSys" style="width: 90%"  placeholder="请选择第三方系统" @change="thirdSysChange">
                        <el-option
                            v-for="item in thirdSys"
                            :key="item.value"
                            :label="item.thirdName"
                            :value="item.thirdId">
                            <span style="float: left">{{ item.thirdName }}</span>
                            <span style="float: right; color: #8492a6; font-size: 13px">{{ item.thirdId }}</span>
                        </el-option>
                    </el-select>
                </el-form-item>
                </el-col>
              </el-row>
            </el-form>

          <div class="top-right-btn">
            <el-button-group style="display:flex;">
              <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
              <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
              <el-button type="primary" icon="el-icon-search" @click="search">查询</el-button>
              <el-button type="primary" icon="el-icon-plus" @click="addProductVisible=true">新增</el-button>
            </el-button-group>
          </div>

          <el-divider style="margin: 15px"></el-divider>

            <el-table v-loading="loading" :data="list" style="width: 100%" border highlight-current-row>
                <el-table-column label="序号" type="index" width="80"></el-table-column>
                <el-table-column label="产品编码" prop="code"></el-table-column>
                <el-table-column label="产品名称" prop="name" show-overflow-tooltip></el-table-column>
                <el-table-column label="规格型号" prop="spec" show-overflow-tooltip></el-table-column>
                <el-table-column label="计量单位" prop="measname" show-overflow-tooltip></el-table-column>
                <el-table-column label="注册/备案凭证" prop="registerNo" show-overflow-tooltip></el-table-column>
                <el-table-column label="生产厂家" prop="manufactory" show-overflow-tooltip></el-table-column>

                <el-table-column label="审核状态" prop="checkStatus" show-overflow-tooltip>
                    <template slot-scope="scope">
                        <span>{{ checkMap[scope.row.checkStatus] }}</span>
                    </template>
                </el-table-column>
                <el-table-column label="操作" width="120">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" @click.native.stop="detailDialog(scope.row)">详情</el-button>
                        <el-button type="text" size="small" @click.native.stop="deleteDialog(scope.row)" v-if="thirdSysDetail.fromType!=0">删除</el-button>
                    </template>
                </el-table-column>
            </el-table>
          <pagination
            v-show="total>0"
            :total="total"
            :limit.sync="filterQuery.limit"
            :page.sync="filterQuery.page"
            @pagination="handleCurrentChange"
          ></pagination>
        </el-card>

        <el-dialog
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            title="产品信息详情"
            :visible.sync="thrProductsDetailVisible"
            width="80%"
            v-if="thrProductsDetailVisible"
        >
            <thrProductsDetail
                :data="thisData"
            ></thrProductsDetail>
        </el-dialog>
        <el-dialog
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            title="审核"
            :visible.sync="checkVisible"
            width="45%"
            v-if="checkVisible">
            <el-button @click="checkVisible = false">取消</el-button>
            <el-button type="primary" @click="checkPass(2)">通过</el-button>
            <el-button type="primary" @click="checkPass(3)">不通过</el-button>
        </el-dialog>
        <el-dialog
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            title="手动添加第三方产品信息关联"
            :visible.sync="addProductVisible"
            width="85%"
            v-if="addProductVisible"
            @close="closeAddDialog"
        >

            <ThrProductsAdd
                :newType="newType"
                :closeAddDialog="closeAddDialog"></ThrProductsAdd>
        </el-dialog>
    </div>
</template>
<script>
import {getThrProducts, delThrProducts, updateProduct} from "../../../api/thrsys/thrProductsAdd";
import {getBasicThirdSys, filterDetailByKey} from "../../../api/basic/basicThirdSys";
import {selectIp} from "@/api/system/systemParamConfig";
import thrProductsDetail from "./supProductsDetail";
import ThrProductsAdd from "@/views/supplier/products/supProductsAdd";

export default {

    data() {
        return {
            showSearch: true,
            filterQuery: {
                code: null,
                name: "",
                spec: null,
                registerNo: null,
                manufactory: null,
                thirdSys: "",
                page: 1,
                limit: 20,
            },
          mainThirdSys:'',
            total: 0,
            thirdSys: [],
            thirdSysDetail: null,
            list: [],
            uploadFileUrl: null,
            fileList: [],
            uploadData: {
                thirdSys: "thirdId",
            },
            addProductVisible: false,
            checkVisible: false,
            newType: 2,
            thrProductsDetailVisible: false,
            thisData: null,
            loading: false,
            checkMap: {
                1: "未审核",
                2: "已审核",
                3: "未通过",
            },
            curRow: null,
        };
    },

    methods: {
        onReset() {
            this.$router.push({
                path: "",
            });
            this.filterQuery = {
                code: null,
                spec: null,
                registerNo: null,
                manufactory: null,
                name: "",
                thirdSys: null,
                page: 1,
                limit: 20,
            };
            this.getList();
        },
        hideSearch() {
          this.showSearch = !this.showSearch;
        },
        search() {
            this.filterQuery.page = 1;
            this.getList();
        },
        checDialog(row) {
            this.checkVisible = true;
            this.curRow = row;
        },
        getList() {
            if (this.filterQuery.thirdSys == null) {
                this.$message.warning("请先选择第三方系统！")
                return;
            }
            this.loading = true;
            getThrProducts(this.filterQuery)
                .then((response) => {
                    // this.loading = false;
                    if (response.code == 20000) {
                        this.list = response.data.list || [];
                        this.total = response.data.total || 0;
                    } else {
                        this.$message.error(response.message);
                    }
                    this.loading = false;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },
      getAllList(){
        getThrProducts(this.filterQuery)
          .then((response) => {
            // this.loading = false;
            if (response.code == 20000) {
              this.list = response.data.list || [];
              this.total = response.data.total || 0;
            } else {
              this.$message.error(response.message);
            }
            this.loading = false;
          })
          .catch(() => {
            this.loading = false;
            this.list = [];
            this.total = 0;
          });
      },
        deleteDialog(row) {
            this.$confirm("此操作将永久删除该产品信息, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    let dQuery = {
                        id: row.id,
                    };
                    delThrProducts(dQuery)
                        .then((response) => {
                            this.loading = false;
                            if (response.code == 20000) {
                                this.$message.success("删除成功");
                                this.getList();
                            } else {
                                this.$message.success(response.message);
                            }
                        })
                        .catch(() => {
                            this.loading = false;
                        });

                })
                .catch(() => {
                });
        },

        detailDialog(row) {
            this.thisData = row;
            this.thrProductsDetailVisible = true;
        },
        getBasicThirdSys() {
            let query = {
                enabled: true,
            };
            getBasicThirdSys(query)
                .then((response) => {
                    this.thirdSys = response.data.list || [];
                  for(var i=0;i<this.thirdSys.length;i++){
                    if(this.thirdSys[i].mainSys){
                      this.filterQuery.thirdSys = this.thirdSys[i].thirdId;
                      this.mainThirdSys = this.thirdSys[i].thirdId;
                    }
                  }
                    this.uploadData.thirdSys = this.filterQuery.thirdSys;
                    this.getThirdSysDetail();
                    this.selectSysParam();
                  //  this.getList();
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });
        },
        getThirdSysDetail() {
            let query = {
                thirdSysFk: this.filterQuery.thirdSys,
                key: "piQueryUrl",
            };
            filterDetailByKey(query)
                .then((response) => {
                    this.thirdSysDetail = response.data;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });

        },
        handleCurrentChange(val) {
            this.filterQuery.page = val.page;
            this.getList();
        },
        handleChange(response, files, fileList) {
            console.log(response);
            if (response.code != 20000) {
                this.$message.error(response.message);
            } else {
                console.log(files[0] + "\n" + this.fileList[0] + "\n" + fileList[0]);
                this.$message.success("文件上传成功,请稍后刷新查看！");
            }
        },
        selectSysParam() {
            let query = {
                key: "thirdIpUrl",
                thirdSysFk: this.filterQuery.thirdSys
            };
            selectIp(query).then((response) => {
                if (response.code == 20000) {
                    this.uploadFileUrl = response.data.thridUrl + "/udiwms/erp/pi/upload";
                }
            });
        },
        thirdSysChange() {
            this.uploadData.thirdSys = this.filterQuery.thirdSysFk;
            this.getThirdSysDetail();
        },
        closeAddDialog(val) {
            if (val) {
                this.getList();
            }
            this.addProductVisible = false;
        },
        checkPass(val) {
            let query = {
                id: this.curRow.id,
                checkStatus: val
            }
            updateProduct(query).then((res) => {
                if (res.code == 20000) {
                    this.getList();
                    this.checkVisible = false;
                } else {
                    this.$message.error(error.message);
                }
            }).catch((error) => {
                this.$message.error(error.message);
            })
        },
    },
    components: {
        thrProductsDetail, ThrProductsAdd
    },
    mounted() {
    },
    created() {
      this.getAllList();
        this.getBasicThirdSys();
    },
};
</script>
<style scoped>
.el-form-item--mini.el-form-item {
  margin-bottom: 9px;
}
</style>
